Solid Example: CreateDebouncedSignal

import { createSignal } from 'solid-js'
import { render } from 'solid-js/web'
import { createDebouncedSignal } from '@tanstack/solid-pacer/debouncer'

function App1() {
  const [instantCount, setInstantCount] = createSignal(0)

  // higher-level hook that uses Solid.createSignal with the state setter automatically debounced
  // optionally, grab the debouncer from the last index of the returned array
  const [debouncedCount, setDebouncedCount, debouncer] = createDebouncedSignal(
    instantCount(),
    {
      wait: 500,
      // enabled: () => instantCount() > 2, // optional, defaults to true
      // leading: true, // optional, defaults to false
    },
    // Alternative to debouncer.Subscribe: pass a selector as 3rd arg to track state and subscribe to updates
    // (state) => ({
    //   executionCount: state.executionCount,
    // }),
  )

  function increment() {
    // this pattern helps avoid common bugs with stale closures and state
    setInstantCount((c) => {
      const newInstantCount = c + 1 // common new value for both
      setDebouncedCount(newInstantCount) // debounced state update
      return newInstantCount // instant state update
    })
  }

  return (
    <div>
      <h1>TanStack Pacer createDebouncedSignal Example 1</h1>
      <table>
        <tbody>
          <debouncer.Subscribe
            selector={(state) => ({
              executionCount: state.executionCount,
            })}
          >
            {(state) => (
              <tr>
                <td>Execution Count:</td>
                <td>{state().executionCount}</td>
              </tr>
            )}
          </debouncer.Subscribe>
          <tr>
            <td colSpan={2}>
              <hr />
            </td>
          </tr>
          <tr>
            <td>Instant Count:</td>
            <td>{instantCount()}</td>
          </tr>
          <tr>
            <td>Debounced Count:</td>
            <td>{debouncedCount()}</td>
          </tr>
        </tbody>
      </table>
      <div>
        <button onClick={increment}>Increment</button>
      </div>
    </div>
  )
}

function App2() {
  const [instantSearch, setInstantSearch] = createSignal('')

  // higher-level hook that uses Solid.createSignal with the state setter automatically debounced
  const [debouncedSearch, setDebouncedSearch, debouncer] =
    createDebouncedSignal(
      instantSearch(),
      {
        wait: 500,
      },
      // Alternative to debouncer.Subscribe: pass a selector as 3rd arg to track state and subscribe to updates
      // (state) => ({
      //   executionCount: state.executionCount,
      // }),
    )

  function handleSearchChange(e: Event) {
    const target = e.target as HTMLInputElement
    const newValue = target.value
    setInstantSearch(newValue)
    setDebouncedSearch(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer createDebouncedSignal Example 2</h1>
      <div>
        <input
          autofocus
          type="search"
          value={instantSearch()}
          onInput={handleSearchChange}
          placeholder="Type to search..."
          style={{ width: '100%' }}
        />
      </div>
      <table>
        <tbody>
          <debouncer.Subscribe
            selector={(state) => ({
              executionCount: state.executionCount,
            })}
          >
            {(state) => (
              <tr>
                <td>Execution Count:</td>
                <td>{state().executionCount}</td>
              </tr>
            )}
          </debouncer.Subscribe>
          <tr>
            <td colSpan={2}>
              <hr />
            </td>
          </tr>
          <tr>
            <td>Instant Search:</td>
            <td>{instantSearch()}</td>
          </tr>
          <tr>
            <td>Debounced Search:</td>
            <td>{debouncedSearch()}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

function App3() {
  const [currentValue, setCurrentValue] = createSignal(50)
  const [instantExecutionCount, setInstantExecutionCount] = createSignal(0)

  // higher-level hook that uses Solid.createSignal with the state setter automatically debounced
  const [debouncedValue, setDebouncedValue, debouncer] = createDebouncedSignal(
    currentValue(),
    {
      wait: 250,
    },
    // Alternative to debouncer.Subscribe: pass a selector as 3rd arg to track state and subscribe to updates
    // (state) => ({
    //   executionCount: state.executionCount,
    // }),
  )

  function handleRangeChange(e: Event) {
    const target = e.target as HTMLInputElement
    const newValue = parseInt(target.value, 10)
    setCurrentValue(newValue)
    setInstantExecutionCount((c) => c + 1)
    setDebouncedValue(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer createDebouncedSignal Example 3</h1>
      <div style={{ 'margin-bottom': '20px' }}>
        <label>
          Current Range:
          <input
            type="range"
            min="0"
            max="100"
            value={currentValue()}
            onInput={handleRangeChange}
            style={{ width: '100%' }}
          />
          <span>{currentValue()}</span>
        </label>
      </div>
      <div style={{ 'margin-bottom': '20px' }}>
        <label>
          Debounced Range (Readonly):
          <input
            type="range"
            min="0"
            max="100"
            value={debouncedValue()}
            readOnly
            style={{ width: '100%' }}
          />
          <span>{debouncedValue()}</span>
        </label>
      </div>
      <table>
        <tbody>
          <tr>
            <td>Instant Executions:</td>
            <td>{instantExecutionCount()}</td>
          </tr>
          <debouncer.Subscribe
            selector={(state) => ({
              executionCount: state.executionCount,
            })}
          >
            {(state) => (
              <>
                <tr>
                  <td>Debounced Executions:</td>
                  <td>{state().executionCount}</td>
                </tr>
                <tr>
                  <td>Saved Executions:</td>
                  <td>{instantExecutionCount() - state().executionCount}</td>
                </tr>
                <tr>
                  <td>% Reduction:</td>
                  <td>
                    {instantExecutionCount() === 0
                      ? '0'
                      : Math.round(
                          ((instantExecutionCount() - state().executionCount) /
                            instantExecutionCount()) *
                            100,
                        )}
                    %
                  </td>
                </tr>
              </>
            )}
          </debouncer.Subscribe>
        </tbody>
      </table>
      <div style={{ color: '#666', 'font-size': '0.9em' }}>
        <p>Debounced with 250ms wait time</p>
      </div>
    </div>
  )
}

render(
  () => (
    <div>
      <App1 />
      <hr />
      <App2 />
      <hr />
      <App3 />
    </div>
  ),
  document.getElementById('root')!,
)
import { createSignal } from 'solid-js'
import { render } from 'solid-js/web'
import { createDebouncedSignal } from '@tanstack/solid-pacer/debouncer'

function App1() {
  const [instantCount, setInstantCount] = createSignal(0)

  // higher-level hook that uses Solid.createSignal with the state setter automatically debounced
  // optionally, grab the debouncer from the last index of the returned array
  const [debouncedCount, setDebouncedCount, debouncer] = createDebouncedSignal(
    instantCount(),
    {
      wait: 500,
      // enabled: () => instantCount() > 2, // optional, defaults to true
      // leading: true, // optional, defaults to false
    },
    // Alternative to debouncer.Subscribe: pass a selector as 3rd arg to track state and subscribe to updates
    // (state) => ({
    //   executionCount: state.executionCount,
    // }),
  )

  function increment() {
    // this pattern helps avoid common bugs with stale closures and state
    setInstantCount((c) => {
      const newInstantCount = c + 1 // common new value for both
      setDebouncedCount(newInstantCount) // debounced state update
      return newInstantCount // instant state update
    })
  }

  return (
    <div>
      <h1>TanStack Pacer createDebouncedSignal Example 1</h1>
      <table>
        <tbody>
          <debouncer.Subscribe
            selector={(state) => ({
              executionCount: state.executionCount,
            })}
          >
            {(state) => (
              <tr>
                <td>Execution Count:</td>
                <td>{state().executionCount}</td>
              </tr>
            )}
          </debouncer.Subscribe>
          <tr>
            <td colSpan={2}>
              <hr />
            </td>
          </tr>
          <tr>
            <td>Instant Count:</td>
            <td>{instantCount()}</td>
          </tr>
          <tr>
            <td>Debounced Count:</td>
            <td>{debouncedCount()}</td>
          </tr>
        </tbody>
      </table>
      <div>
        <button onClick={increment}>Increment</button>
      </div>
    </div>
  )
}

function App2() {
  const [instantSearch, setInstantSearch] = createSignal('')

  // higher-level hook that uses Solid.createSignal with the state setter automatically debounced
  const [debouncedSearch, setDebouncedSearch, debouncer] =
    createDebouncedSignal(
      instantSearch(),
      {
        wait: 500,
      },
      // Alternative to debouncer.Subscribe: pass a selector as 3rd arg to track state and subscribe to updates
      // (state) => ({
      //   executionCount: state.executionCount,
      // }),
    )

  function handleSearchChange(e: Event) {
    const target = e.target as HTMLInputElement
    const newValue = target.value
    setInstantSearch(newValue)
    setDebouncedSearch(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer createDebouncedSignal Example 2</h1>
      <div>
        <input
          autofocus
          type="search"
          value={instantSearch()}
          onInput={handleSearchChange}
          placeholder="Type to search..."
          style={{ width: '100%' }}
        />
      </div>
      <table>
        <tbody>
          <debouncer.Subscribe
            selector={(state) => ({
              executionCount: state.executionCount,
            })}
          >
            {(state) => (
              <tr>
                <td>Execution Count:</td>
                <td>{state().executionCount}</td>
              </tr>
            )}
          </debouncer.Subscribe>
          <tr>
            <td colSpan={2}>
              <hr />
            </td>
          </tr>
          <tr>
            <td>Instant Search:</td>
            <td>{instantSearch()}</td>
          </tr>
          <tr>
            <td>Debounced Search:</td>
            <td>{debouncedSearch()}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

function App3() {
  const [currentValue, setCurrentValue] = createSignal(50)
  const [instantExecutionCount, setInstantExecutionCount] = createSignal(0)

  // higher-level hook that uses Solid.createSignal with the state setter automatically debounced
  const [debouncedValue, setDebouncedValue, debouncer] = createDebouncedSignal(
    currentValue(),
    {
      wait: 250,
    },
    // Alternative to debouncer.Subscribe: pass a selector as 3rd arg to track state and subscribe to updates
    // (state) => ({
    //   executionCount: state.executionCount,
    // }),
  )

  function handleRangeChange(e: Event) {
    const target = e.target as HTMLInputElement
    const newValue = parseInt(target.value, 10)
    setCurrentValue(newValue)
    setInstantExecutionCount((c) => c + 1)
    setDebouncedValue(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer createDebouncedSignal Example 3</h1>
      <div style={{ 'margin-bottom': '20px' }}>
        <label>
          Current Range:
          <input
            type="range"
            min="0"
            max="100"
            value={currentValue()}
            onInput={handleRangeChange}
            style={{ width: '100%' }}
          />
          <span>{currentValue()}</span>
        </label>
      </div>
      <div style={{ 'margin-bottom': '20px' }}>
        <label>
          Debounced Range (Readonly):
          <input
            type="range"
            min="0"
            max="100"
            value={debouncedValue()}
            readOnly
            style={{ width: '100%' }}
          />
          <span>{debouncedValue()}</span>
        </label>
      </div>
      <table>
        <tbody>
          <tr>
            <td>Instant Executions:</td>
            <td>{instantExecutionCount()}</td>
          </tr>
          <debouncer.Subscribe
            selector={(state) => ({
              executionCount: state.executionCount,
            })}
          >
            {(state) => (
              <>
                <tr>
                  <td>Debounced Executions:</td>
                  <td>{state().executionCount}</td>
                </tr>
                <tr>
                  <td>Saved Executions:</td>
                  <td>{instantExecutionCount() - state().executionCount}</td>
                </tr>
                <tr>
                  <td>% Reduction:</td>
                  <td>
                    {instantExecutionCount() === 0
                      ? '0'
                      : Math.round(
                          ((instantExecutionCount() - state().executionCount) /
                            instantExecutionCount()) *
                            100,
                        )}
                    %
                  </td>
                </tr>
              </>
            )}
          </debouncer.Subscribe>
        </tbody>
      </table>
      <div style={{ color: '#666', 'font-size': '0.9em' }}>
        <p>Debounced with 250ms wait time</p>
      </div>
    </div>
  )
}

render(
  () => (
    <div>
      <App1 />
      <hr />
      <App2 />
      <hr />
      <App3 />
    </div>
  ),
  document.getElementById('root')!,
)

TanStack

Svelte Example: CreateDebouncedSignal

<script lang="ts">
  import { TanStackDevtools } from '@tanstack/svelte-devtools'
  import { pacerDevtoolsPlugin } from '@tanstack/svelte-pacer-devtools'
  import { untrack } from 'svelte'
  import { createDebouncedSignal } from '@tanstack/svelte-pacer/debouncer'

  let instantCount = $state(0)

  let instantCountRef = $state(0)

  const [debouncedCount, setDebouncedCount, counterDebouncer] =
    createDebouncedSignal(
      untrack(() => instantCount),
      () => ({
        wait: 500,
        // enabled: () => instantCount > 2, // optional, defaults to true
        // leading: true, // optional, defaults to false
      }),
    )

  function increment() {
    const nextCount = ++instantCountRef
    instantCount = nextCount
    setDebouncedCount(nextCount)
  }

  let currentValue = $state(50)

  let instantExecutionCount = $state(0)

  const [debouncedValue, setDebouncedValue, rangeDebouncer] =
    createDebouncedSignal(
      untrack(() => currentValue),
      () => ({
        wait: 250,
      }),
    )

  function handleRangeChange(e: Event) {
    const newValue = parseInt((e.target as HTMLInputElement).value, 10)
    currentValue = newValue
    instantExecutionCount = instantExecutionCount + 1
    setDebouncedValue(newValue)
  }

  let instantSearch = $state('')

  let instantSearchRef = $state('')

  const [debouncedSearch, setDebouncedSearch, searchDebouncer] =
    createDebouncedSignal(
      untrack(() => instantSearch),
      () => ({
        wait: 500,
        enabled: () => instantSearchRef.length > 2, // optional, defaults to true
      }),
    )

  function handleSearchChange(e: Event) {
    const newValue = (e.target as HTMLInputElement).value
    instantSearchRef = newValue
    instantSearch = newValue
    setDebouncedSearch(newValue)
  }
</script>

<div>
  <div>
    <h1>TanStack Pacer createDebouncedSignal Example 1</h1>
    <table>
      <tbody
        ><counterDebouncer.Subscribe
          selector={(state) => ({
            isPending: state.isPending,
            executionCount: state.executionCount,
          })}
          >{#snippet children({ isPending, executionCount })}<tr
              ><td>Is Pending:</td><td>{isPending.toString()}</td></tr
            ><tr><td>Execution Count:</td><td>{executionCount}</td></tr><tr
              ><td colspan={2}><hr /></td></tr
            ><tr><td>Instant Count:</td><td>{instantCount}</td></tr><tr
              ><td>Debounced Count:</td><td>{debouncedCount()}</td></tr
            >{/snippet}</counterDebouncer.Subscribe
        ></tbody
      >
    </table>
    <div><button onclick={increment}>Increment</button></div>
    <counterDebouncer.Subscribe selector={(state) => state}
      >{#snippet children(state)}<pre style="margin-top: 20px">{JSON.stringify(
            state,
            null,
            2,
          )}</pre>{/snippet}</counterDebouncer.Subscribe
    >
  </div>
  <hr />
  <div>
    <h1>TanStack Pacer createDebouncedSignal Example 2</h1>
    <div>
      <input
        type="search"
        value={instantSearch}
        oninput={handleSearchChange}
        placeholder="Type to search..."
        style="width: 100%"
      />
    </div>
    <table>
      <tbody
        ><searchDebouncer.Subscribe
          selector={(state) => ({
            isPending: state.isPending,
            executionCount: state.executionCount,
          })}
          >{#snippet children({ isPending, executionCount })}<tr
              ><td>Is Pending:</td><td>{isPending.toString()}</td></tr
            ><tr><td>Execution Count:</td><td>{executionCount}</td></tr><tr
              ><td colspan={2}><hr /></td></tr
            ><tr><td>Instant Search:</td><td>{instantSearch}</td></tr><tr
              ><td>Debounced Search:</td><td>{debouncedSearch()}</td></tr
            >{/snippet}</searchDebouncer.Subscribe
        ></tbody
      >
    </table>
    <searchDebouncer.Subscribe selector={(state) => state}
      >{#snippet children(state)}<pre style="margin-top: 20px">{JSON.stringify(
            state,
            null,
            2,
          )}</pre>{/snippet}</searchDebouncer.Subscribe
    >
  </div>
  <hr />
  <div>
    <h1>TanStack Pacer createDebouncedSignal Example 3</h1>
    <div style="margin-bottom: 20px">
      <label
        >Current Range:<input
          type="range"
          min="0"
          max="100"
          value={currentValue}
          oninput={handleRangeChange}
          style="width: 100%"
        /><span>{currentValue}</span></label
      >
    </div>
    <div style="margin-bottom: 20px">
      <label
        >Debounced Range (Readonly):<input
          type="range"
          min="0"
          max="100"
          value={debouncedValue()}
          disabled
          style="width: 100%"
        /><span>{debouncedValue()}</span></label
      >
    </div>
    <table>
      <tbody
        ><rangeDebouncer.Subscribe
          selector={(state) => ({
            isPending: state.isPending,
            executionCount: state.executionCount,
          })}
          >{#snippet children({ isPending, executionCount })}<tr
              ><td>Is Pending:</td><td>{isPending.toString()}</td></tr
            ><tr
              ><td>Instant Executions:</td><td>{instantExecutionCount}</td></tr
            ><tr><td>Debounced Executions:</td><td>{executionCount}</td></tr><tr
              ><td>Saved Executions:</td><td
                >{instantExecutionCount - executionCount}</td
              ></tr
            ><tr
              ><td>% Reduction:</td><td
                >{#if instantExecutionCount === 0}{'0'}{:else}{Math.round(
                    ((instantExecutionCount - executionCount) /
                      instantExecutionCount) *
                      100,
                  )}{/if}%
              </td></tr
            >{/snippet}</rangeDebouncer.Subscribe
        ></tbody
      >
    </table>
    <div style="color: #666; font-size: 0.9em">
      <p>Debounced to 250ms wait time</p>
    </div>
    <rangeDebouncer.Subscribe selector={(state) => state}
      >{#snippet children(state)}<pre style="margin-top: 20px">{JSON.stringify(
            state,
            null,
            2,
          )}</pre>{/snippet}</rangeDebouncer.Subscribe
    >
  </div>
</div>
{#if import.meta.env.DEV}<TanStackDevtools
    plugins={[pacerDevtoolsPlugin()]}
  />{/if}